# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetCustomRoutingEndpointTrafficPoliciesResult',
    'AwaitableGetCustomRoutingEndpointTrafficPoliciesResult',
    'get_custom_routing_endpoint_traffic_policies',
    'get_custom_routing_endpoint_traffic_policies_output',
]

@pulumi.output_type
class GetCustomRoutingEndpointTrafficPoliciesResult:
    """
    A collection of values returned by getCustomRoutingEndpointTrafficPolicies.
    """
    def __init__(__self__, accelerator_id=None, address=None, custom_routing_endpoint_traffic_policies=None, endpoint_group_id=None, endpoint_id=None, id=None, ids=None, listener_id=None, output_file=None, page_number=None, page_size=None):
        if accelerator_id and not isinstance(accelerator_id, str):
            raise TypeError("Expected argument 'accelerator_id' to be a str")
        pulumi.set(__self__, "accelerator_id", accelerator_id)
        if address and not isinstance(address, str):
            raise TypeError("Expected argument 'address' to be a str")
        pulumi.set(__self__, "address", address)
        if custom_routing_endpoint_traffic_policies and not isinstance(custom_routing_endpoint_traffic_policies, list):
            raise TypeError("Expected argument 'custom_routing_endpoint_traffic_policies' to be a list")
        pulumi.set(__self__, "custom_routing_endpoint_traffic_policies", custom_routing_endpoint_traffic_policies)
        if endpoint_group_id and not isinstance(endpoint_group_id, str):
            raise TypeError("Expected argument 'endpoint_group_id' to be a str")
        pulumi.set(__self__, "endpoint_group_id", endpoint_group_id)
        if endpoint_id and not isinstance(endpoint_id, str):
            raise TypeError("Expected argument 'endpoint_id' to be a str")
        pulumi.set(__self__, "endpoint_id", endpoint_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if listener_id and not isinstance(listener_id, str):
            raise TypeError("Expected argument 'listener_id' to be a str")
        pulumi.set(__self__, "listener_id", listener_id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if page_number and not isinstance(page_number, int):
            raise TypeError("Expected argument 'page_number' to be a int")
        pulumi.set(__self__, "page_number", page_number)
        if page_size and not isinstance(page_size, int):
            raise TypeError("Expected argument 'page_size' to be a int")
        pulumi.set(__self__, "page_size", page_size)

    @property
    @pulumi.getter(name="acceleratorId")
    def accelerator_id(self) -> str:
        """
        The ID of the GA instance to which the endpoint belongs.
        """
        return pulumi.get(self, "accelerator_id")

    @property
    @pulumi.getter
    def address(self) -> Optional[str]:
        """
        The IP address of the traffic policy.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="customRoutingEndpointTrafficPolicies")
    def custom_routing_endpoint_traffic_policies(self) -> Sequence['outputs.GetCustomRoutingEndpointTrafficPoliciesCustomRoutingEndpointTrafficPolicyResult']:
        """
        A list of Custom Routing Endpoint Traffic Policies. Each element contains the following attributes:
        """
        return pulumi.get(self, "custom_routing_endpoint_traffic_policies")

    @property
    @pulumi.getter(name="endpointGroupId")
    def endpoint_group_id(self) -> Optional[str]:
        """
        The ID of the Custom Routing Endpoint Group.
        """
        return pulumi.get(self, "endpoint_group_id")

    @property
    @pulumi.getter(name="endpointId")
    def endpoint_id(self) -> Optional[str]:
        """
        The ID of the Custom Routing Endpoint.
        """
        return pulumi.get(self, "endpoint_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Sequence[str]:
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter(name="listenerId")
    def listener_id(self) -> Optional[str]:
        """
        The ID of the custom routing listener to which the endpoint belongs.
        """
        return pulumi.get(self, "listener_id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="pageNumber")
    def page_number(self) -> Optional[int]:
        return pulumi.get(self, "page_number")

    @property
    @pulumi.getter(name="pageSize")
    def page_size(self) -> Optional[int]:
        return pulumi.get(self, "page_size")


class AwaitableGetCustomRoutingEndpointTrafficPoliciesResult(GetCustomRoutingEndpointTrafficPoliciesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCustomRoutingEndpointTrafficPoliciesResult(
            accelerator_id=self.accelerator_id,
            address=self.address,
            custom_routing_endpoint_traffic_policies=self.custom_routing_endpoint_traffic_policies,
            endpoint_group_id=self.endpoint_group_id,
            endpoint_id=self.endpoint_id,
            id=self.id,
            ids=self.ids,
            listener_id=self.listener_id,
            output_file=self.output_file,
            page_number=self.page_number,
            page_size=self.page_size)


def get_custom_routing_endpoint_traffic_policies(accelerator_id: Optional[str] = None,
                                                 address: Optional[str] = None,
                                                 endpoint_group_id: Optional[str] = None,
                                                 endpoint_id: Optional[str] = None,
                                                 ids: Optional[Sequence[str]] = None,
                                                 listener_id: Optional[str] = None,
                                                 output_file: Optional[str] = None,
                                                 page_number: Optional[int] = None,
                                                 page_size: Optional[int] = None,
                                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCustomRoutingEndpointTrafficPoliciesResult:
    """
    This data source provides the Global Accelerator (GA) Custom Routing Endpoint Traffic Policies of the current Alibaba Cloud user.

    > **NOTE:** Available in 1.197.0+

    ## Example Usage

    Basic Usage

    ```python
    import pulumi
    import pulumi_alicloud as alicloud

    ids = alicloud.ga.get_custom_routing_endpoint_traffic_policies(ids=["example_id"],
        accelerator_id="your_accelerator_id")
    pulumi.export("gaCustomRoutingEndpointTrafficPoliciesId1", ids.custom_routing_endpoint_traffic_policies[0].id)
    ```


    :param str accelerator_id: The ID of the GA instance to which the traffic policies belong.
    :param str address: The IP addresses of the traffic policies.
    :param str endpoint_group_id: The ID of the endpoint group to which the traffic policies belong.
    :param str endpoint_id: The ID of the endpoint to which the traffic policies belong.
    :param Sequence[str] ids: A list of Custom Routing Endpoint Traffic Policy IDs.
    :param str listener_id: The ID of the listener to which the traffic policies belong.
    :param str output_file: File name where to save data source results (after running `pulumi preview`).
    """
    __args__ = dict()
    __args__['acceleratorId'] = accelerator_id
    __args__['address'] = address
    __args__['endpointGroupId'] = endpoint_group_id
    __args__['endpointId'] = endpoint_id
    __args__['ids'] = ids
    __args__['listenerId'] = listener_id
    __args__['outputFile'] = output_file
    __args__['pageNumber'] = page_number
    __args__['pageSize'] = page_size
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('alicloud:ga/getCustomRoutingEndpointTrafficPolicies:getCustomRoutingEndpointTrafficPolicies', __args__, opts=opts, typ=GetCustomRoutingEndpointTrafficPoliciesResult).value

    return AwaitableGetCustomRoutingEndpointTrafficPoliciesResult(
        accelerator_id=pulumi.get(__ret__, 'accelerator_id'),
        address=pulumi.get(__ret__, 'address'),
        custom_routing_endpoint_traffic_policies=pulumi.get(__ret__, 'custom_routing_endpoint_traffic_policies'),
        endpoint_group_id=pulumi.get(__ret__, 'endpoint_group_id'),
        endpoint_id=pulumi.get(__ret__, 'endpoint_id'),
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'),
        listener_id=pulumi.get(__ret__, 'listener_id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        page_number=pulumi.get(__ret__, 'page_number'),
        page_size=pulumi.get(__ret__, 'page_size'))


@_utilities.lift_output_func(get_custom_routing_endpoint_traffic_policies)
def get_custom_routing_endpoint_traffic_policies_output(accelerator_id: Optional[pulumi.Input[str]] = None,
                                                        address: Optional[pulumi.Input[Optional[str]]] = None,
                                                        endpoint_group_id: Optional[pulumi.Input[Optional[str]]] = None,
                                                        endpoint_id: Optional[pulumi.Input[Optional[str]]] = None,
                                                        ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                                        listener_id: Optional[pulumi.Input[Optional[str]]] = None,
                                                        output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                                        page_number: Optional[pulumi.Input[Optional[int]]] = None,
                                                        page_size: Optional[pulumi.Input[Optional[int]]] = None,
                                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCustomRoutingEndpointTrafficPoliciesResult]:
    """
    This data source provides the Global Accelerator (GA) Custom Routing Endpoint Traffic Policies of the current Alibaba Cloud user.

    > **NOTE:** Available in 1.197.0+

    ## Example Usage

    Basic Usage

    ```python
    import pulumi
    import pulumi_alicloud as alicloud

    ids = alicloud.ga.get_custom_routing_endpoint_traffic_policies(ids=["example_id"],
        accelerator_id="your_accelerator_id")
    pulumi.export("gaCustomRoutingEndpointTrafficPoliciesId1", ids.custom_routing_endpoint_traffic_policies[0].id)
    ```


    :param str accelerator_id: The ID of the GA instance to which the traffic policies belong.
    :param str address: The IP addresses of the traffic policies.
    :param str endpoint_group_id: The ID of the endpoint group to which the traffic policies belong.
    :param str endpoint_id: The ID of the endpoint to which the traffic policies belong.
    :param Sequence[str] ids: A list of Custom Routing Endpoint Traffic Policy IDs.
    :param str listener_id: The ID of the listener to which the traffic policies belong.
    :param str output_file: File name where to save data source results (after running `pulumi preview`).
    """
    ...
