# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetVulWhitelistsResult',
    'AwaitableGetVulWhitelistsResult',
    'get_vul_whitelists',
    'get_vul_whitelists_output',
]

@pulumi.output_type
class GetVulWhitelistsResult:
    """
    A collection of values returned by getVulWhitelists.
    """
    def __init__(__self__, id=None, ids=None, output_file=None, page_number=None, page_size=None, whitelists=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if page_number and not isinstance(page_number, int):
            raise TypeError("Expected argument 'page_number' to be a int")
        pulumi.set(__self__, "page_number", page_number)
        if page_size and not isinstance(page_size, int):
            raise TypeError("Expected argument 'page_size' to be a int")
        pulumi.set(__self__, "page_size", page_size)
        if whitelists and not isinstance(whitelists, list):
            raise TypeError("Expected argument 'whitelists' to be a list")
        pulumi.set(__self__, "whitelists", whitelists)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Sequence[str]:
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="pageNumber")
    def page_number(self) -> Optional[int]:
        return pulumi.get(self, "page_number")

    @property
    @pulumi.getter(name="pageSize")
    def page_size(self) -> Optional[int]:
        return pulumi.get(self, "page_size")

    @property
    @pulumi.getter
    def whitelists(self) -> Sequence['outputs.GetVulWhitelistsWhitelistResult']:
        """
        A list of Vul Whitelist Entries. Each element contains the following attributes:
        """
        return pulumi.get(self, "whitelists")


class AwaitableGetVulWhitelistsResult(GetVulWhitelistsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVulWhitelistsResult(
            id=self.id,
            ids=self.ids,
            output_file=self.output_file,
            page_number=self.page_number,
            page_size=self.page_size,
            whitelists=self.whitelists)


def get_vul_whitelists(ids: Optional[Sequence[str]] = None,
                       output_file: Optional[str] = None,
                       page_number: Optional[int] = None,
                       page_size: Optional[int] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVulWhitelistsResult:
    """
    This data source provides Threat Detection Vul Whitelists of the current Alibaba Cloud user.

    > **NOTE:** Available in v1.195.0+.

    ## Example Usage

    Basic Usage

    ```python
    import pulumi
    import pulumi_alicloud as alicloud

    default = alicloud.threatdetection.get_vul_whitelists(ids=["example_id"])
    pulumi.export("alicloudThreatDetectionVulWhitelistExampleId", default.whitelists[0].id)
    ```


    :param Sequence[str] ids: A list of Threat Detection Vul Whitelist IDs.
    :param str output_file: File name where to save data source results (after running `pulumi preview`).
    """
    __args__ = dict()
    __args__['ids'] = ids
    __args__['outputFile'] = output_file
    __args__['pageNumber'] = page_number
    __args__['pageSize'] = page_size
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('alicloud:threatdetection/getVulWhitelists:getVulWhitelists', __args__, opts=opts, typ=GetVulWhitelistsResult).value

    return AwaitableGetVulWhitelistsResult(
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'),
        output_file=pulumi.get(__ret__, 'output_file'),
        page_number=pulumi.get(__ret__, 'page_number'),
        page_size=pulumi.get(__ret__, 'page_size'),
        whitelists=pulumi.get(__ret__, 'whitelists'))


@_utilities.lift_output_func(get_vul_whitelists)
def get_vul_whitelists_output(ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                              output_file: Optional[pulumi.Input[Optional[str]]] = None,
                              page_number: Optional[pulumi.Input[Optional[int]]] = None,
                              page_size: Optional[pulumi.Input[Optional[int]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetVulWhitelistsResult]:
    """
    This data source provides Threat Detection Vul Whitelists of the current Alibaba Cloud user.

    > **NOTE:** Available in v1.195.0+.

    ## Example Usage

    Basic Usage

    ```python
    import pulumi
    import pulumi_alicloud as alicloud

    default = alicloud.threatdetection.get_vul_whitelists(ids=["example_id"])
    pulumi.export("alicloudThreatDetectionVulWhitelistExampleId", default.whitelists[0].id)
    ```


    :param Sequence[str] ids: A list of Threat Detection Vul Whitelist IDs.
    :param str output_file: File name where to save data source results (after running `pulumi preview`).
    """
    ...
